--Librera Funciones Basicas PSPCleaner
--[***FUNCINES PARA EL FUNCIONAMIENTO DEL MEN***]--

negro = Color.new(0, 0, 0,255)
silver = Color.new(255,255,255,255)

--Funcin para Verificar el Custom Firmware del PSP
function PSPCustomFirmware()
while true do
System.message("*PSPCleaner por Migueliziosop.\nCualquier duda o comentario visitar:\nwww.Migueliziosop.Foroactivo.com",0)
if System.cfwVersion() == "5.50" or "5.00" or "5.03" or "5.02"or "4.01" then
dofile("./system/PSPCleanerLogo.LUA")

else

System.message("PSPCleaner ah detectado que su Custom Firmware es menor a la version 4.01.\nFavor de actualizar.",0)
System.Quit()
end
end
end

function PSPCustomFirmware2()
while true do
System.message("*PSPCleaner by Migueliziosop.\nAny questions or comments visit:\nwww.Migueliziosop.Foroactivo.com",0)
if System.cfwVersion() == "5.50" or "5.00" or "5.03" or "5.02"or "4.01" then
dofile("./system/PSPCleanerLogo.LUA")

else

System.message("PSPCleaner detected that your Custom Firmware is not 4.01.\nPlease, update your CFW.",0)
System.Quit()
end
end
end

--Funcin para Verificar el Tipo del PSP (NO FUNCIONA POR AHORA)
function PSPCheckTipoPSP()
while true do
TipoPSP = System.getModel(0)
if TipoPSP == 1000 or 1001 then
screen.print(175,70,"PHAT",.8,amarillo,0)
break

elseif TipoPSP == 2000 or 2001 then
screen.print(175,70,"Slim ",.8,amarillo,0)
break
end
end
end

--Funcin para "Dormir" el PSP
function PSPCSleep500()
System.sleep(500)
end

--Funcin para el Movimiento & Sonido de los Mens
function PSPCMoveSoundUP()
if pad:up() and oldpad:up() ~= pad:up() then
current = current-1
beep:play()
end
end

function PSPCMoveSoundDOWN()
if pad:down() and oldpad:down() ~= pad:down() then
current = current+1
beep:play()
end
end

--**[[Funcines para Diferentes "Dofiles"]]**
--Funcin para Cargar la Librera especial "PSPCLib"
function PSPCLibLoad()
dofile("./system/PSPCleanerLib.LUA")
end  

--Funcin para conectar el USB a Memory Stick
function PSPCUSB()
System.usbDiskModeActivate()
end

--Funcin para asignar la Flash1
function PSPCAsignarFlash1()
System.unassign("flash1:")
System.assign ( "flash1:", "lflash0:0,1", "flashfat1:")
end

--Funcin para Regresar/Ir al PixelCleaner
function PSPCDofilePixelCleaner()
dofile("./system/PSPCPixelCleaner.LUA")
end

--Funcin para Regresar/Ir al Men
function PSPCDofileMenu()
dofile("ms0:/PSP/GAME/PSPCleaner/system/PSPCleanerMenu.LUA")
end

--Funcin para Regresar/Ir al Dumpeador
function PSPCDofileDumper()
dofile("./system/PSPCleanerDumper.LUA")
end

--Funcin para Regresar/Ir al Limpiador
function PSPCDofileLimpiador()
dofile("./system/PSPCleanerLimpiador.LUA")
end

--Funcin para Regresar/Ir a Informacin del Sistema
function PSPCDofileInformation()
dofile("./system/PSPCleanerInformation.LUA")
end

--Funcin para Regresar/Ir a Extras
function PSPCDofileExtras()
dofile("./system/PSPCleanerExtras.LUA")
end

--Funcin para Regresar/Ir a Configuracin
function PSPCDofileConfiguration()
dofile("./system/PSPCleanerConfigutarion.LUA")
end

--Funcin para Regresar/Ir a Idioma
function PSPCDofileIdioma()
dofile("./system/PSPCleanerIdioma.LUA")
end

----++++****Funcin DOFILES en Ingls****++++----
--Funcin para Regresar/Ir al PixelCleaner
function PSPCDofilePixelCleaner2()
dofile("./system/PSPCEnglish/PSPCPixelCleaner.LUA")
end

--Funcin para Regresar/Ir al Men
function PSPCDofileMenu2()
dofile("ms0:/PSP/GAME/PSPCleaner/System/PSPCEnglish/PSPCleanerMenu.LUA")
end

--Funcin para Regresar/Ir al Dumpeador
function PSPCDofileDumper2()
dofile("./system/PSPCEnglish/PSPCleanerDumper.LUA")
end

--Funcin para Regresar/Ir al Limpiador
function PSPCDofileLimpiador2()
dofile("./system/PSPCEnglish/PSPCleanerLimpiador.LUA")
end

--Funcin para Regresar/Ir a Informacin del Sistema
function PSPCDofileInformation2()
dofile("./system/PSPCEnglish/PSPCleanerInformation.LUA")
end

--Funcin para Regresar/Ir a Extras
function PSPCDofileExtras2()
dofile("ms0:/PSP/GAME/PSPCleaner/System/PSPCEnglish/PSPCleanerExtras.LUA")
end

--Funcin para Regresar/Ir a Configuracin
function PSPCDofileConfiguration2()
dofile("./system/PSPCEnglish/PSPCleanerConfigutarion.LUA")
end

--Funcin para Mostrar Creditos
function PSPCredits()
System.message("************************************************\n****  CREDITOS PSPCleaner v.1.5    ****\n************************************************\n              *[Desarrolladores]*\n                    Migueliziosop\n\n                   *[Grafistas]*\n         M14_b2, elvamo & Germax\n\n                   *[BetaTesters]*\nGermax, Mr.Bryann, EsTuArT, Unicorn & Dannysbkn.\n\n                 *[Pagina Oficial]*\n      www.Migueliziosop.Foroactivo.com  ",0)
System.message("************************************************\n****  CREDITOS PSPCleaner v.1.5    ****\n************************************************\n           *[Colaboradores Especiales]*\n           Mr. Bryann & Germax\n\n             *[Gracias a estos Chicos]*\nGermax, Omar Planas, The Dark, Bowser85, Zheive, M14_b2, Dark_Santi, Guillermo Cornielle, Unicorn y Mr.Shizzy.",0)
System.message("************************************************\n****  CREDITOS PSPCleaner v.1.5    ****\n************************************************\n        *[Paginas del Autor]*\n    PSP.SceneBeta.com\n        www.Evoconsolas.com\n          www.ellimite.org\n       www.PSPStation.org\n    www.TodoScene.net\n & gracias a ti " ..PSPCApodoPSP,0)
end

function PSPCredits2()
System.message("************************************************\n****  CREDITS PSPCleaner v.1.5    ****\n************************************************\n                  *[Developers]*\n                  Migueliziosop\n\n                 *[Graphic Designers]*\n         M14_b2, elvamo & Germax\n\n                *[BetaTesters]*\nGermax, Mr.Bryann, EsTuArT, Unicorn & Dannysbkn.\n\n               *[Oficial Page]*\n   www.Migueliziosop.Foroactivo.com  ",0)
System.message("************************************************\n****  CREDITS PSPCleaner v.1.5    ****\n************************************************\n           *[Special Collaborators]*\n           Mr. Bryann & Germax\n\n             *[Thanks to this guys]*\nGermax, Omar Planas, The Dark, Bowser85, Zheive, M14_b2, Dark-Santi, Guillermo Cornielle, Unicorn y Mr.Shizzy.",0)
System.message("************************************************\n****  CREDITS PSPCleaner v.1.5    ****\n************************************************\n        *[Other pages of Autor]*\n    PSP.SceneBeta.com\n   www.Evoconsolas.com\n   www.ellimite.org\n  www.PSPStation.org\n    www.TodoScene.net\n & thanks you " ..PSPCApodoPSP,0)
end

--Funcin para Reiniciar PSP
function PSPCRestarPSP()
System.runeboot("ms0:/PSP/GAME/PSPCleaner/System/PSPCRestart.pbp")
end

--Funcin para Actualizar PSPCleaner
function PSPCUpdate()
System.runeboot("ms0:/PSP/GAME/PSPCleaner/System/PSPCleanerUpdate/PSPCUpdate.pbp")
end

--Funcin para Apagar PSP
function PSPCPowerOFF()
System.shutdown()
end

--Funcin para Suspender el PSP
function PSPCStandby()
System.suspend()
end

--Funcin para Salir a XMB
function PSPCExit()
System.Quit()
end

--Funcin para Mostrar el Mensaje de "An no Disponible.."
function PSPCNoDisponible()
System.message("Aun no disponible..",0)
end

function PSPCNoDisponible2()
System.message("Not available..",0)
end

--Funcin para poner CPU a 333
function PSPCPU333()
System.setcpuspeed(333)
end

--Funcin para Limpiar Memoria RAM
function PSPCleanMemoryRam()
System.memclean()
collectgarbage("collect")
end

----++++Funcin para el Creador de Carpetas++++----
function PSPCreatorFolders()
System.createDirectory("ms0:/ISO")
System.createDirectory("ms0:/ISO/VIDEO")
System.createDirectory("ms0:/MUSIC")
System.createDirectory("ms0:/PICTURE")
System.createDirectory("ms0:/SEPLUGINS")
System.createDirectory("ms0:/MP_ROOT")
System.createDirectory("ms0:/MP_ROOT/100MNV01")
System.createDirectory("ms0:/MP_ROOT/101ANV01")
System.createDirectory("ms0:/PSP")
System.createDirectory("ms0:/PSP/GAME")
System.createDirectory("ms0:/PSP/COMMON")
System.createDirectory("ms0:/PSP/GAME150")
System.createDirectory("ms0:/PSP/LICENSE")
System.createDirectory("ms0:/PSP/MUSIC")
System.createDirectory("ms0:/PSP/PHOTO")
System.createDirectory("ms0:/PSP/RADIOPLAYER")
System.createDirectory("ms0:/PSP/RSSCH")
System.createDirectory("ms0:/PSP/RSSCH/IMPORT")
System.createDirectory("ms0:/PSP/SAVEDATA")
System.createDirectory("ms0:/PSP/SYSTEM")
System.createDirectory("ms0:/PSP/SYSTEM/BROWSER")
System.createDirectory("ms0:/PSP/SYSTEM/INFOBOARD")
System.createDirectory("ms0:/PSP/RSSCH/CHANNELS")
System.createDirectory("ms0:/PSP/RSSCH/TEMP")
System.createDirectory("ms0:/PSP/RSSCH/TEMP/IMAGE")
System.createDirectory("ms0:/PSP/RSSCH/TEMP/ITEM")
System.createDirectory("ms0:/PSP/THEME")
System.createDirectory("ms0:/PSP/VIDEO")
System.createDirectory("ms0:/VIDEO")
end



--Funcines para el Funcionamiento de la Prueba de Ad-Hoc
--Funcn para Iniciar el Ad-Hoc
function PSPCInitAdhoc()
pad = Controls.read()
wlanon = Controls.wlan()

if pad:wlan() == 0 or false then
System.message("El interruptor WLAN esta apagado, favor de prenderlo",0)
dofile("./system/PSPCleanerExtras.lua")
else

Adhoc.init()
end
end

--Funcin para Conectarse al Ad-Hoc
function PSPConnectAdhoc()
Adhoc.connect() 
end

--Funcin para Mostrar el Estado del AdHoc
estadoadhoc = Adhoc.getState()
estateadhoc = Adhoc.getState()

function PSPCMessageAdhocState()
System.message("El estado de AdHoc es  " .. estadoadhoc,0)
end

--Funcin para Mostrar el Significado del Estado
function PSPCMessageAdhocSignificate()
System.message("Significa que " .. stat,0)
end

--Funcin para Terminar el AdHoc
function PSPCEndAdHoc()
Adhoc.term()
end

--Funcin para Probar Ad-Hoc
function PSPCAdhoc()
PSPCInitAdhoc()
PSPConnectAdhoc()

while true do

estadoadhoc = Adhoc.getState()

if estadoadhoc == 1 then 
stat = "Todo Bien"
end

PSPCMessageAdhocState()

if estadoadhoc == 1 then
    stat = "esta todo Bien"
end

if estadoadhoc == 0 then
    stat = "se ah producido un error"
end
PSPCMessageAdhocSignificate()


while true do
  
screen.waitVblankStart()
    
PSPCleanMemoryRam()
    
Adhoc.term()
PSPCDofileExtras()
      end
   end
end
--------Adhoc en ingls------
function PSPCInitAdhoc2()
pad = Controls.read()
wlanon = Controls.wlan()

if pad:wlan() == 0 or false then
System.message("The WLAN switch is not turned on, please, turned on",0)
dofile("./system/PSPCEnglish/PSPCleanerExtras.lua")
else

Adhoc.init()
end
end

function PSPCMessageAdhocState2()
System.message("The state of AdHoc is  " .. estateadhoc,0)
end

--Funcin para Mostrar el Significado del Estado
function PSPCMessageAdhocSignificate2()
System.message("Means that " .. status,0)
end

--Funcin para Probar Ad-Hoc
function PSPCAdhoc2()
PSPCInitAdhoc2()
PSPConnectAdhoc()

while true do

estateadhoc = Adhoc.getState()

if estateadhoc == 1 then 
status = "All Good"
end

PSPCMessageAdhocState2()

if estateadhoc == 1 then
    status = "Is everything all right"
end

if estateadhoc == 0 then
    status = "An error has been produced"
end
PSPCMessageAdhocSignificate2()


while true do
  
screen.waitVblankStart()
    
PSPCleanMemoryRam()
    
Adhoc.term()
PSPCDofileExtras2()
      end
   end
end

--[***FUNCINES PARA EL FUNCIONAMIENTO DEL LIMPIADOR***]--

--Funcin Borrar Historial
function PSPCleanHistory()
System.removeFile("ms0:/PSP/SYSTEM/BROWSER/historyv.dat")
end

--Funcin Borrar Bookmarks/Favoritos
function PSPCleanBookmarks()
System.removeFile("ms0:/PSP/SYSTEM/BROWSER/bookmarks.html")     
end

--Funcin Borrar Configuracin VSH Men
function PSPCleanConfigMenuVSH()
System.removeFile("flash1:/config.se")
end

--Funcin Borrar Fondo de Pantalla
function PSPCleanWallpaper()
System.removeFile("flash1:/vsh/theme/wallpaper.bmp")
end

--Funcin Borrar Cookies
function PSPCleanCookies()
System.removeFile("flash1:/net/http/cookie.dat")
end

--Funcin Borrar Bsquedas de Google
function PSPCleanGoogleSearch()
System.removeFile("ms0:/PSP/SYSTEM/BROWSER/historys.dat")
end

--Funcin Borrar Autoentificacin
function PSPCleanAutoentificacion()
System.removeFile("flash1:/net/http/auth.dat")
end

--Funcin Borrar IsoCache
function PSPCleanIsoCache()
System.removeFile("ms0:/PSP/SYSTEM/isocache.bin")
end

--Funcin Borrar Configuracin Ultimate VSH Men
function PSPCleanConfigUVM()
System.removeFile("flash1:/Config.uvm")
end

--Funcin Borrar LuaPlayerHM8 Drivers
function PSPCleanLPHM8Drivers()
System.removeFile("ms0:/seplugins/load.PBP")
System.removeFile("ms0:/seplugins/hook.txt")
System.removeFile("flash1:/LPHMDRIVER/hook.prx")
System.removeFile("flash1:/LPHMDRIVER/rdriver.prx")
System.removeFile("flash1:/LPHMDRIVER/syslib.prx")
System.removeDirectory("flash1:/LPHMDRIVER")
end

--Funcin Borrar Nand previamente Dumpeada con Open Source Nand Dumper 3.xx
function PSPCleanNandDump()
System.removeFile("ms0:/nand-dump.bin")
end

--Funcin Borrar IPL previamente Dumpeado
function PSPCleanIPL()
System.removeFile("ms0:/ipl.bin")
end

--Funcin Borrar Eeprom previamente Dumpeada
function PSPCleanEeprom()
System.removeFile("ms0:/eeprom.bin")
end

--Funcin Borrar Reproductor Player 1
function PSPCleanRadioPlayer1()
System.removeFile("ms0:/PSP/RADIOPLAYER/InternetRadioPlayerI.prs")
end

--Funcin Borrar Reproductor Player 2
function PSPCleanRadioPlayer2()
System.removeFile("ms0:/PSP/RADIOPLAYER/InternetRadioPlayerII.prs")
end

--Funcin Borrar Cuenta Skype
function PSPCleanSkype()
    checar = System.doesDirExist("ms0:/PSP/SYSTEM/SKYPE") 
    if checar == 1 then
        System.currentDirectory("ms0:/PSP/SYSTEM/SKYPE") 
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do
            if archivos[z].directory == false then
                System.removeFile(archivos[z].name)
            end
        end
        System.removeDirectory("ms0:/PSP/SYSTEM/SKYPE")        
    end
end

--Funcin Borrar Historial del Plug-In Protec-Me
function PSPCleanHistProtecme()
System.removeFile("ms0:/PSP/SYSTEM/hist.txt")
end

--Funcin Borrar Imgenes Virtual Globe
function PSPCleanVirtualGlobe()
    checar = System.doesDirExist("ms0:/PSP/GAME/VirtualGlobe/Data")
    if checar == 1 then
        System.currentDirectory("ms0:/PSP/GAME/VirtualGlobe/Data") 
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do
            if archivos[z].directory == false then
                System.removeFile(archivos[z].name)
            end
        end      
    end
end

--Funcin Borrar Archivos PReSS
function PSPCleanPReSS()
    checar = System.doesDirExist("ms0:/PReSS data/feeds")
    if checar == 1 then
        System.currentDirectory("ms0:/PReSS data/feeds") 
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do
            if archivos[z].directory == false then
                System.removeFile(archivos[z].name)
            end
        end      
    end
end

--Funcin Borrar Cookies de DownPSP
function PSPCleanCookieDownPSP()
System.removeFile("ms0:/PSP/GAME/downPSP_C/SBcookie")
System.removeFile("ms0:/PSP/GAME/downPSP_C/lastTimeLoggedIn")
end


--Funcin Borrar Temas 
function PSPCleanThemes()
    checar = System.doesDirExist("ms0:/PSP/THEME")
    if checar == 1 then
        System.currentDirectory("ms0:/PSP/THEME") 
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do
            if archivos[z].directory == false then
                System.removeFile(archivos[z].name)
            end
        end      
    end
end

--Funcin Borrar Musica
function PSPCleanMusic()
    checar = System.doesDirExist("ms0:/MUSIC")
    if checar == 1 then
        System.currentDirectory("ms0:/MUSIC")
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do
            if archivos[z].directory == false then
                System.removeFile(archivos[z].name)
            end
        end      
    end
end

--Funcin Borrar Fotos
function PSPCleanPicture()
    checar = System.doesDirExist("ms0:/PICTURE")
    if checar == 1 then
        System.currentDirectory("ms0:/PICTURE")
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do
            if archivos[z].directory == false then
                System.removeFile(archivos[z].name)
            end
        end      
    end
end

--Funcin Borrar TimeMachine
function PSPCleanTM()
    checar = System.doesDirExist("ms0:/TM")
    if checar == 1 then
        System.currentDirectory("ms0:/TM")
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do
            if archivos[z].directory == false then
                System.removeFile(archivos[z].name)
            end
        end      
    end
end

--Funcin Borrar Videos
function PSPCleanVideos()
    checar = System.doesDirExist("ms0:/VIDEO")
    if checar == 1 then
        System.currentDirectory("ms0:/VIDEO")
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do
            if archivos[z].directory == false then
                System.removeFile(archivos[z].name)
            end
        end      
    end
end

--Funcin Borrar Flash-Backup
function PSPCleanBackUpsRF()
    checar = System.doesDirExist("ms0:/flash-backup")
    if checar == 1 then
        System.currentDirectory("ms0:/flash-backup")
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do
            if archivos[z].directory == false then
                System.removeFile(archivos[z].name)
            end
        end      
    end
end

--Funcin Borrar videos PSPTube
function PSPCleanPSPTube()
    checar = System.doesDirExist("ms0:/PSP/GAME/PSPTube/favorites")
    if checar == 1 then
        System.currentDirectory("ms0:/PSP/GAME/PSPTube/favorites") 
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do
            if archivos[z].directory == false then
                System.removeFile(archivos[z].name)
            end
        end      
    end
end

--Funcin para Borrar archivos de INFOBOARD
function PSPCleanINFOBOARD()
    checar = System.doesDirExist("ms0:/PSP/SYSTEM/INFOBOARD")
    if checar == 1 then
        System.currentDirectory("ms0:/PSP/SYSTEM/INFOBOARD") 
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do
            if archivos[z].directory == false then
                System.removeFile(archivos[z].name)
            end
        end      
    end
end

--Funcin para Borrar archivos de los Canales RSS
function PSPCleanRSSChannels()
    checar = System.doesDirExist("ms0:/PSP/SYSTEM/RSSCH")
    if checar == 1 then
        System.currentDirectory("ms0:/PSP/SYSTEM/RSSCH") 
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do
            if archivos[z].directory == false then
                System.removeFile(archivos[z].name)
            end
        end      
    end
end

--Funcin para Borrar todos los Plugins
function PSPCleanPlugins()
    checar = System.doesDirExist("ms0:/seplugins")
    if checar == 1 then
        System.currentDirectory("ms0:/seplugins") 
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do
            if archivos[z].directory == false then
                System.removeFile(archivos[z].name)
            end
        end      
    end
end

--Funcin para Borrar archivos de los SaveData's
function PSPCleanSaveData()
    checar = System.doesDirExist("ms0:/PSP/SAVEDATA")
    if checar == 1 then
        System.currentDirectory("ms0:/PSP/SAVEDATA") 
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do
            if archivos[z].directory == false then
                System.removeFile(archivos[z].name)
            end
        end      
    end
end

--Funcin para Borrar Clips de Radio
function PSPCleanClipsRadio()
System.removeFile("ms0:/PSP/RADIOPLAYER/clip_80s.prs")
System.removeFile("ms0:/PSP/RADIOPLAYER/clip_game.prs")
System.removeFile("ms0:/PSP/RADIOPLAYER/clip_jazz.prs")
System.removeFile("ms0:/PSP/RADIOPLAYER/clip_relax.prs")
System.removeFile("ms0:/PSP/RADIOPLAYER/clip_soundtrack.prs")
System.removeFile("ms0:/PSP/RADIOPLAYER/os_AWayToRelax.prs")
System.removeFile("ms0:/PSP/RADIOPLAYER/os_CoffeeOrTea.prs")
System.removeFile("ms0:/PSP/RADIOPLAYER/os_JazzOrNot.prs")
System.removeFile("ms0:/PSP/RADIOPLAYER/os_LatinOn.prs")
System.removeFile("ms0:/PSP/RADIOPLAYER/os_LikeOnTheRadio.prs")
end

--Funcin para Borrar Portales aka "COMMON"
function PSPCleanCOMMON()
    checar = System.doesDirExist("ms0:/PSP/COMMON")
    if checar == 1 then
        System.currentDirectory("ms0:/PSP/COMMON") 
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do
            if archivos[z].directory == false then
                System.removeFile(archivos[z].name)
            end
        end      
    end
end

--Funcin para borrar las NAND's dumpeadas del Hellcat's Recovery Flasher
function PSPCleanNandRecoveryFlasher()
    checar = System.doesDirExist("ms0:/flash_nanddumps")
    if checar == 1 then
        System.currentDirectory("ms0:/flash_nanddumps") 
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do
            if archivos[z].directory == false then
                System.removeFile(archivos[z].name)
            end
        end      
    end
end


--Funcin para Cambiar de Pgina en el Limpiador al Pulsar R
function PSPCDiferentPageR()
if pad:r() and current == 1 then
current = 11  
end

if pad:r() and current == 2 then
current = 11    
end
    
if pad:r() and current == 3 then
current = 11    
end

if pad:r() and current == 4 then
current = 11    
end

if pad:r() and current == 5 then
current = 11    
end

if pad:r() and current == 6 then
current = 11    
end

if pad:r() and current == 7 then
current = 11    
end

if pad:r() and current == 8 then
current = 11    
end

if pad:r() and current == 9 then
current = 11    
end

if pad:r() and current == 10 then
current = 11    
end

if pad:r() and current == 11 then
current = 21
end

if pad:r() and current == 12 then
current = 21
end

if pad:r() and current == 13 then
current = 21   
end

if pad:r() and current == 14 then
current = 21  
end

if pad:r() and current == 15 then
current = 21  
end

if pad:r() and current == 16 then
current = 21
end

if pad:r() and current == 17 then
current = 21
end

if pad:r() and current == 18 then
current = 21
end

if pad:r() and current == 19 then
current = 21
end

if pad:r() and current == 20 then
current = 21
end

if pad:r() and current == 21 then
current = 1 
end

if pad:r() and current == 22 then
current = 1 
end

if pad:r() and current == 23 then
current = 1 
end

if pad:r() and current == 24 then
current = 1 
end

if pad:r() and current == 25 then
current = 1 
end

if pad:r() and current == 26 then
current = 1 
end

if pad:r() and current == 27 then
current = 1 
end

if pad:r() and current == 28 then
current = 1 
end

if pad:r() and current == 28 then
current = 1 
end

if pad:r() and current == 29 then
current = 1 
end

if pad:r() and current == 30 then
current = 1 
end

end

--Funcin para Cambiar de Pgina en el Limpiador al Pulsar L
function PSPCDiferentPageL()
if pad:l() and current == 1 then
current = 30
end

if pad:l() and current == 2 then
current = 30
end

if pad:l() and current == 3 then
current = 30
end

if pad:l() and current == 4 then
current = 30
end

if pad:l() and current == 5 then
current = 30
end

if pad:l() and current == 6 then
current = 30
end

if pad:l() and current == 7 then
current = 30
end

if pad:l() and current == 8 then
current = 30
end

if pad:l() and current == 9 then
current = 30
end

if pad:l() and current == 10 then
current = 30
end

if pad:l() and current == 11 then
current = 1 
end

if pad:l() and current == 12 then
current = 1
end

if pad:l() and current == 13 then
current = 1
end

if pad:l() and current == 14 then
current = 1
end

if pad:l() and current == 15 then
current = 1
end

if pad:l() and current == 16 then
current = 1
end

if pad:l() and current == 17 then
current = 1
end

if pad:l() and current == 18 then
current = 1
end

if pad:l() and current == 19 then
current = 1
end

if pad:l() and current == 20 then
current = 1
end

if pad:r() and current == 21 then
current = 11
end

if pad:r() and current == 22 then
current = 11
end

if pad:r() and current == 23 then
current = 11
end

if pad:r() and current == 24 then
current = 11
end

if pad:r() and current == 25 then
current = 11
end

if pad:r() and current == 26 then
current = 11
end

if pad:r() and current == 27 then
current = 11
end

if pad:r() and current == 28 then
current = 11
end

if pad:r() and current == 28 then
current = 11
end

if pad:r() and current == 29 then
current = 11
end

if pad:r() and current == 30 then
current = 11
end
end

---||||||||||||||||||||||||||||||||||||||||||||||||||||||||---
---|||||||||Funciones de Dumpeo en Flash0 y Flash1|||||||||---
---||||||||||||||||||||||||||||||||||||||||||||||||||||||||---

--Funcin Dumpear Flash1
--Crear Directorios Correspondientes en Memory Stick de Flash1
function PSPCDUMPF1(modo)
	if modo == "PSPCrearDirectorios" then
		System.createDirectory("ms0:/PSPCDUMPS")
		System.createDirectory("ms0:/PSPCDUMPS/Flash1")
		checar = System.doesDirExist("flash1:/dic") 
		if checar == 1 then 
			System.createDirectory("ms0:/PSPCDUMPS/Flash1/dic")
		end
System.sleep(500)
		checar = System.doesDirExist("flash1:/gps") 
		if checar == 1 then 
			System.createDirectory("ms0:/PSPCDUMPS/Flash1/gps")
		end

		checar = System.doesDirExist("flash1:/net") 
		if checar == 1 then
			System.createDirectory("ms0:/PSPCDUMPS/Flash1/net")
		end

		checar = System.doesDirExist("flash1:/net/http") 
		if checar == 1 then 
			System.createDirectory("ms0:/PSPCDUMPS/Flash1/net/http")
		end

		checar = System.doesDirExist("flash1:/registry") 
		if checar == 1 then 
			System.createDirectory("ms0:/PSPCDUMPS/Flash1/registry")
		end

		checar = System.doesDirExist("flash1:/updater") 
		if checar == 1 then 
			System.createDirectory("ms0:/PSPCDUMPS/Flash1/updater")
		end
        
		System.sleep(500)
		
		checar = System.doesDirExist("flash1:/vsh") 
		if checar == 1 then 
			System.createDirectory("ms0:/PSPCDUMPS/Flash1/vsh")
		end

		checar = System.doesDirExist("flash1:/vsh/theme") 
		if checar == 1 then 
			System.createDirectory("ms0:/PSPCDUMPS/Flash1/vsh/theme")
		end
	PSPCleanMemoryRam()
	end

--Copiar Archivos de Flash1 hacia Memory Stick
	if modo == "PSPCopyArchives" then
		
		--Dumpear Config.Se
		--Configuracin del VSH Men
		checar = System.doesFileExist("flash1:/config.se") 
		if checar == 1 then 
			System.copyFile("flash1:/config.se", "ms0:/PSPCDUMPS/Flash1/config.se", 0)
		end

		--Dumpear Config.note
		checar = System.doesFileExist("flash1:/config.note") 
		if checar == 1 then 
			System.copyFile("flash1:/config.note", "ms0:/PSPCDUMPS/Flash1/config.note", 0)
		end

		--Archivo del Coder Red Squirrel
		checar = System.doesFileExist("flash1:/squirrel.red") 
		if checar == 1 then
			System.copyFile("flash1:/squirrel.red", "ms0:/PSPCDUMPS/Flash1/squirrel.red", 0)
		end

		--Dumpear archivos de la carpeta DIC de Flash1 en Memory Stick
		checar = System.doesDirExist("flash1:/dic") 
		if checar == 1 then 
			System.currentDirectory("flash1:/dic") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do --Dumpear todos los archivos de la carpeta DIC
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash1/dic/" ..archivos[z].name,0)
				end
			end
		end

		--Dumpear archivos de la carpeta GPS de Flash1 en Memory Stick
		checar = System.doesDirExist("flash1:/gps") 
		if checar == 1 then 
			System.currentDirectory("flash1:/gps") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do --Dumpear todos los archivos de la carpeta GPS
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash1/gps/" ..archivos[z].name,0)
				end
			end
		end

System.sleep(500)
		
		--Dumpear archivos de la carpeta NET en Flash1 en Memory Stick
		checar = System.doesDirExist("flash1:/net") 
		if checar == 1 then 
			System.currentDirectory("flash1:/net") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do --Dumpear todos los archivos de la carpeta NET
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash1/net/" ..archivos[z].name,0)
                 PSPCleanMemoryRam()
				end
			end
		end
		
		--Dumpear archivos de la carpeta NET/HTTP en Flash1 en Memory Stick
		checar = System.doesDirExist("flash1:/net/http") 
		if checar == 1 then 
			System.currentDirectory("flash1:/net/http") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do --Dumpear todos los archivos de la carpeta NET/HTTP
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash1/net/http/" ..archivos[z].name,0)
				end
			end
		end

		--Dumpear archivos de la carpeta REGISTRY en Flash1 en Memory Stick
		checar = System.doesDirExist("flash1:/registry") 
		if checar == 1 then 
			System.currentDirectory("flash1:/registry") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do --Dumpear todos los archivos de la carpeta REGISTRY
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash1/registry/" ..archivos[z].name,0)
				end
			end
		end
		
		--Dumpear archivos de la carpeta UPDATER en Flash1 en Memory Stick
		checar = System.doesDirExist("flash1:/updater") 
		if checar == 1 then
			System.currentDirectory("flash1:/updater") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do --Dumpear todos los archivos de la carpeta UPDATER
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash1/updater/" ..archivos[z].name,0)
				System.memclean()
				collectgarbage("collect")
				end
			end
		end

		--Dumpear archivos de la carpeta VSH en Flash1 en Memory Stick
		checar = System.doesDirExist("flash1:/vsh") 
		if checar == 1 then 
			System.currentDirectory("flash1:/vsh") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do -- Pour tout les archivos
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash1/vsh/" ..archivos[z].name,0)
				end
			end
		end
System.sleep(500)
		--vsh/theme
		checar = System.doesDirExist("flash1:/vsh/theme") 
		if checar == 1 then 
			System.currentDirectory("flash1:/vsh/theme") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do -- Pour tout les archivos
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash1/vsh/theme/" ..archivos[z].name,0)
				end
			end
		PSPCleanMemoryRam()
		end
	end
end

--Funcin Dumpear Flash0
function PSPCDUMPF0(modo)
PSPCleanMemoryRam()
	if modo == "PSPCrearDirectorios" then
		System.createDirectory("ms0:/PSPCDUMPS")
		System.createDirectory("ms0:/PSPCDUMPS/Flash0")

		checar = System.doesDirExist("flash0:/data") 
		if checar == 1 then 
			System.createDirectory("ms0:/PSPCDUMPS/Flash0/data")
		end

		checar = System.doesDirExist("flash0:/data/cert") 
		if checar == 1 then 
			System.createDirectory("ms0:/PSPCDUMPS/Flash0/data/cert")
		end

		checar = System.doesDirExist("flash0:/dic") 
		if checar == 1 then
			System.createDirectory("ms0:/PSPCDUMPS/Flash0/dic")
		end

		checar = System.doesDirExist("flash0:/font") 
		if checar == 1 then 
			System.createDirectory("ms0:/PSPCDUMPS/Flash0/font")
		end

		checar = System.doesDirExist("flash0:/kd") 
		if checar == 1 then 
			System.createDirectory("ms0:/PSPCDUMPS/Flash0/kd")
		end

		checar = System.doesDirExist("flash0:/kd/resource") 
		if checar == 1 then 
			System.createDirectory("ms0:/PSPCDUMPS/Flash0/kd/resource")
		end

		checar = System.doesDirExist("flash0:/km") 
		if checar == 1 then 
			System.createDirectory("ms0:/PSPCDUMPS/Flash0/km")
		end

		checar = System.doesDirExist("flash0:/km/resource") 
		if checar == 1 then 
			System.createDirectory("ms0:/PSPCDUMPS/Flash0/km/resource")
		end
			checar = System.doesDirExist("flash0:/vsh") 
		if checar == 1 then 
			System.createDirectory("ms0:/PSPCDUMPS/Flash0/vsh")
		end

			checar = System.doesDirExist("flash0:/vsh/etc") 
		if checar == 1 then 
			System.createDirectory("ms0:/PSPCDUMPS/Flash0/vsh/etc")
		end

			checar = System.doesDirExist("flash0:/vsh/module") 
		if checar == 1 then 
			System.createDirectory("ms0:/PSPCDUMPS/Flash0/vsh/module")
		end

		checar = System.doesDirExist("flash0:/vsh/podule") 
		if checar == 1 then 
			System.createDirectory("ms0:/PSPCDUMPS/Flash0/vsh/podule")
		end
		
		checar = System.doesDirExist("flash0:/vsh/resource") 
		if checar == 1 then 
			System.createDirectory("ms0:/PSPCDUMPS/Flash0/vsh/resource")
		end
PSPCleanMemoryRam()
    end

---------------------------

	if modo == "PSPCopyArchives" then

		--dic
		checar = System.doesDirExist("flash0:/data") 
		if checar == 1 then 
			System.currentDirectory("flash0:/data") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do -- Pour tout les archivos
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash0/data/" ..archivos[z].name,0)
				end
			end
		end
System.sleep(500)
		--gps
		checar = System.doesDirExist("flash0:/data/cert") 
		if checar == 1 then 
			System.currentDirectory("flash0:/data/cert") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 
			
			for z = 1, nombre_archivos do -- Pour tout les archivos
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash0/data/cert/" ..archivos[z].name,0)
				end
			end
		end

		--net
		checar = System.doesDirExist("flash0:/dic") 
		if checar == 1 then 
			System.currentDirectory("flash0:/dic") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do -- Pour tout les archivos
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash0/dic/" ..archivos[z].name,0)
				end
			end
		end

		--net/http
		checar = System.doesDirExist("flash0:/font") 
		if checar == 1 then 
			System.currentDirectory("flash0:/font") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do -- Pour tout les archivos
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash0/font/" ..archivos[z].name,0)
				System.memclean()
				end
			end
		end
		
System.sleep(500)

		--registry
		checar = System.doesDirExist("flash0:/kd") 
		if checar == 1 then 
			System.currentDirectory("flash0:/kd") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do -- Pour tout les archivos
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash0/kd/" ..archivos[z].name,0)
				System.memclean()
				end
			end
		end

		--updater
		checar = System.doesDirExist("flash0:/kd/resource") 
		if checar == 1 then
			System.currentDirectory("flash0:/kd/resource") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do -- Pour tout les archivos
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash0/kd/resource/" ..archivos[z].name,0)
				end
			end
		end
System.sleep(500)
		--vsh
		checar = System.doesDirExist("flash0:/km") 
		if checar == 1 then 
			System.currentDirectory("flash0:/km") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do -- Pour tout les archivos
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash0/km/" ..archivos[z].name,0)
				end
			end
		end

				checar = System.doesDirExist("flash0:/km/resource") 
		if checar == 1 then 
			System.currentDirectory("flash0:/km/resource") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do -- Pour tout les archivos
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash0/km/resource/" ..archivos[z].name,0)
				end
			end
		end
		
				checar = System.doesDirExist("flash0:/vsh") 
		if checar == 1 then 
			System.currentDirectory("flash0:/vsh") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do -- Pour tout les archivos
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash0/vsh/" ..archivos[z].name,0)
				end
			end
		end
System.sleep(500)		
				checar = System.doesDirExist("flash0:/vsh/etc") 
		if checar == 1 then 
			System.currentDirectory("flash0:/vsh/etc") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do -- Pour tout les archivos
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash0/vsh/etc/" ..archivos[z].name,0)
PSPCleanMemoryRam()
				end
			end
		end
		
					checar = System.doesDirExist("flash0:/vsh/module") 
		if checar == 1 then 
			System.currentDirectory("flash0:/vsh/module") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do -- Pour tout les archivos
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash0/vsh/module/" ..archivos[z].name,0)
				end
			end
		end
		
		checar = System.doesDirExist("flash0:/vsh/podule") 
		if checar == 1 then 
			System.currentDirectory("flash0:/vsh/podule") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 
	
			for z = 1, nombre_archivos do -- Pour tout les archivos
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash0/vsh/podule/" ..archivos[z].name,0)
				System.memclean()
				end
			end
		end
System.sleep(500)
		checar = System.doesDirExist("flash0:/vsh/resource") 
		if checar == 1 then 
			System.currentDirectory("flash0:/vsh/resource") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do -- Pour tout les archivos
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash0/vsh/resource/" ..archivos[z].name,0)
				end
			end
		end
	
		--vsh/theme
		checar = System.doesDirExist("flash0:/km/resource") 
		if checar == 1 then 
			System.currentDirectory("flash0:/km/resource") 
			archivos = System.listDirectory() 
			nombre_archivos = table.getn(archivos) 

			for z = 1, nombre_archivos do -- Pour tout les archivos
				if archivos[z].directory == false then
					System.copyFile(archivos[z].name,"ms0:/PSPCDUMPS/Flash0/km/resource/" ..archivos[z].name,0)
				end
			end
		PSPCleanMemoryRam()
		end
     end
end   

--Funcin para Restaurar Flash1
function PSPCleanFlash1()
	checar = System.doesDirExist("flash1:/dic") 
	if checar == 1 then
		System.currentDirectory("flash1:/dic") 
		archivos = System.listDirectory() 
		nombre_archivos = table.getn(archivos) 

		for z = 1, nombre_archivos do
			if archivos[z].directory == false then
				System.removeFile(archivos[z].name)
			end
		end
	end

	checar = System.doesDirExist("flash1:/gps") 
	if checar == 1 then
		System.currentDirectory("flash1:/gps") 
		archivos = System.listDirectory() 
		nombre_archivos = table.getn(archivos) 

		for z = 1, nombre_archivos do
			if archivos[z].directory == false then
			System.memclean()
			collectgarbage()
				System.removeFile(archivos[z].name)
			end
		end
		System.removeDirectory("flash1:/gps")
	end

	checar = System.doesDirExist("flash1:/net/http") 
	if checar == 1 then
		System.currentDirectory("flash1:/net/http") 
		archivos = System.listDirectory() 
		nombre_archivos = table.getn(archivos) 

		for z = 1, nombre_archivos do
			if archivos[z].directory == false then
				System.removeFile(archivos[z].name)
			end
		end
	end

	checar = System.doesDirExist("flash1:/net") 
	if checar == 1 then
		System.currentDirectory("flash1:/net") 
		archivos = System.listDirectory() 
		nombre_archivos = table.getn(archivos) 

		for z = 1, nombre_archivos do
			if archivos[z].directory == false then
				System.removeFile(archivos[z].name)
			end
		end
	end

	checar = System.doesDirExist("flash1:/registry") 
	if checar == 1 then
		System.currentDirectory("flash1:/registry") 
		archivos = System.listDirectory() 
		nombre_archivos = table.getn(archivos) 

		for z = 1, nombre_archivos do
			if archivos[z].directory == false then
				System.removeFile(archivos[z].name)
			end
		end
	end

	checar = System.doesDirExist("flash1:/updater") 
	if checar == 1 then
		System.currentDirectory("flash1:/updater") 
		archivos = System.listDirectory() 
		nombre_archivos = table.getn(archivos) 

		for z = 1, nombre_archivos do
			if archivos[z].directory == false then
				System.removeFile(archivos[z].name)
			end
		end
		System.removeDirectory("flash1:/updater")
	end

	checar = System.doesDirExist("flash1:/vsh/theme") 
	if checar == 1 then
		System.currentDirectory("flash1:/vsh/theme") 
		archivos = System.listDirectory() 
		nombre_archivos = table.getn(archivos) 

		for z = 1, nombre_archivos do
			if archivos[z].directory == false then
				System.removeFile(archivos[z].name)
			end
		end
	end

	checar = System.doesDirExist("flash1:/vsh") 
	if checar == 1 then
		System.currentDirectory("flash1:/vsh") 
		archivos = System.listDirectory() 
		nombre_archivos = table.getn(archivos) 

		for z = 1, nombre_archivos do
			if archivos[z].directory == false then
				System.removeFile(archivos[z].name)
			end
		end
	end

	checar = System.doesFileExist("flash1:/config.se") 
	if checar == 1 then 
		System.removeFile("flash1:/config.se")
	end

	checar = System.doesFileExist("flash1:/config.note") 
	if checar == 1 then 
		System.removeFile("flash1:/config.note")
	end

	checar = System.doesFileExist("flash1:/squirrel.red") 
	if checar == 1 then 
		System.removeFile("flash1:/squirrel.red")
	end
	PSPCExit()
end

--Funcin para Restaurar Flash1
function PSPCRestoreFlash1()
    --Creat directories in f1--
    System.createDirectory("flash1:/dic")
    System.createDirectory("flash1:/gps")
    System.createDirectory("flash1:/net")
    System.createDirectory("flash1:/net/http")
    System.createDirectory("flash1:/registry")
    System.createDirectory("flash1:/updater")
    System.createDirectory("flash1:/vsh")
    System.createDirectory("flash1:/vsh/theme")
    
    checar = System.doesFileExist("ms0:/PSPCDUMPS/config.se") 
    if checar == 1 then 
        System.copyFile("ms0:/PSPCDUMPS/config.se", "flash1:/config.se", 0)
    end

    checar = System.doesFileExist("ms0:/PSPCDUMPS/config.note") 
    if checar == 1 then 
        System.copyFile("ms0:/PSPCDUMPS/config.se", "flash1:/config.note", 0)
    end

    checar = System.doesFileExist("ms0:/PSPCDUMPS/squirrel.red") 
    if checar == 1 then 
        System.copyFile("ms0:/PSPCDUMPS/config.se", "flash1:/squirrel.red", 0)
    end

    --dic
    checar = System.doesDirExist("ms0:/PSPCDUMPS/dic") 
    if checar == 1 then 
        System.currentDirectory("ms0:/PSPCDUMPS/dic") 
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do 
            if archivos[z].directory == false then
                System.copyFile(archivos[z].name,"flash1:/dic/" ..archivos[z].name,0)
            end
        end
    end

    --gps
    checar = System.doesDirExist("ms0:/PSPCDUMPS/gps") 
    if checar == 1 then 
        System.currentDirectory("ms0:/PSPCDUMPS/gps") 
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do -- Pour tout les archivos
            if archivos[z].directory == false then
                System.copyFile(archivos[z].name,"flash1:/gps/" ..archivos[z].name,0)
            end
        end
    end

    --net
    checar = System.doesDirExist("ms0:/PSPCDUMPS/net") 
    if checar == 1 then 
        System.currentDirectory("ms0:/PSPCDUMPS/net") 
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do -- Pour tout les archivos
            if archivos[z].directory == false then
                System.copyFile(archivos[z].name,"flash1:/PSPCDUMPS/net/" ..archivos[z].name,0)
            end
        end
    end

    --net/http
    checar = System.doesDirExist("ms0:/PSPCDUMPS/net/http") 
    if checar == 1 then 
        System.currentDirectory("ms0:/PSPCDUMPS/net/http") 
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do -- Pour tout les archivos
            if archivos[z].directory == false then
                System.copyFile(archivos[z].name,"flash1:/net/http/" ..archivos[z].name,0)
            end
        end
    end

    --registry
    checar = System.doesDirExist("ms0:/PSPCDUMPS/registry") 
    if checar == 1 then 
        System.currentDirectory("ms0:/PSPCDUMPS/registry") 
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do -- Pour tout les archivos
            if archivos[z].directory == false then
                System.copyFile(archivos[z].name,"flash1:/registry/" ..archivos[z].name,0)
            end
        end
    end

    --updater
    checar = System.doesDirExist("ms0:/PSPCDUMPS/updater") 
    if checar == 1 then 
        System.currentDirectory("ms0:/PSPCDUMPS/updater") 
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do -- Pour tout les archivos
            if archivos[z].directory == false then
                System.copyFile(archivos[z].name,"flash1:/updater/" ..archivos[z].name,0)
            end
        end
    end

    --vsh
    checar = System.doesDirExist("ms0:/PSPCDUMPS/vsh") 
    if checar == 1 then 
        System.currentDirectory("ms0:/PSPCDUMPS/vsh") 
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do -- Pour tout les archivos
            if archivos[z].directory == false then
                System.copyFile(archivos[z].name,"flash1:/vsh/" ..archivos[z].name,0)
            end
        end
    end

    --vsh/theme
    checar = System.doesDirExist("ms0:/PSPCDUMPS/vsh/theme") 
    if checar == 1 then 
        System.currentDirectory("ms0:/PSPCDUMPS/vsh/theme") 
        archivos = System.listDirectory() 
        nombre_archivos = table.getn(archivos) 

        for z = 1, nombre_archivos do -- Pour tout les archivos
            if archivos[z].directory == false then
                System.copyFile(archivos[z].name,"flash1:/vsh/theme/" ..archivos[z].name,0)
            end
        end
    end
end

--------------------------------------------------------------
--=================Funciones de Transparencia=================--
--------------------------------------------------------------

--Funcin de Transparencia para la Informacin del Sistema
function PSPCTransparent()
crono = Timer.new()
crono:start()

TRANS3 = Image.load("Imagenes/TRANS3.png")
TRANS4 = Image.load("Imagenes/TRANS4.png")


while true do
tiempo = crono:time()

if tiempo > 0 and tiempo < 1000 then
	 screen.startDraw()
	 screen.clear(0)
	 Image.blit(0,0,TRANS3)
	 screen.endDraw()
end

if tiempo > 1000 and tiempo < 2000 then
	 screen.startDraw()
	 screen.clear(0)
	 Image.blit(0,0,TRANS3)
	 screen.endDraw()
end
 
if tiempo > 2000 and tiempo < 3000 then
	 screen.startDraw()
	 screen.clear(0)
	 Image.blit(0,0,TRANS4)
	 screen.print(155,260,"Loading...",.9,silver,negro,0)
	 screen.endDraw()
end 
 
if tiempo > 3000 and tiempo < 4000 then
	 screen.startDraw()
	 screen.clear(0)
	 Image.blit(0,0,TRANS4)
	 screen.endDraw()
	 break
end

screen.waitVblankStart()
screen.flipscreen()

end
end

function PSPCTransparent2()
crono = Timer.new()
crono:start()

TRANS2 = Image.load("Imagenes/TRANS2.png")
TRANS3 = Image.load("Imagenes/TRANS3.png")
TRANS4 = Image.load("Imagenes/TRANS4.png")


while true do
tiempo = crono:time()

if tiempo > 0 and tiempo < 800 then
	 screen.startDraw()
	 screen.clear(0)
	 Image.blit(0,0,TRANS4)
	 screen.endDraw()
end

if tiempo > 800 and tiempo < 1600 then
	 screen.startDraw()
	 screen.clear(0)
	 Image.blit(0,0,TRANS3)
	 screen.endDraw()
end
 
if tiempo > 1600 and tiempo < 2400 then
	 screen.startDraw()
	 screen.clear(0)
	 Image.blit(0,0,TRANS2)
	 screen.print(155,260,"Loading...",.9,silver,negro,0)
	 screen.endDraw()
end
 
if tiempo > 2400 and tiempo < 3200 then
	 screen.startDraw()
	 screen.clear(0)
	 Image.blit(0,0,TRANS2)
	 screen.endDraw()
	 break
end

screen.waitVblankStart()
screen.flipscreen()
end
end

-- FUNCTION METATABLE (NO USES AS OF NOW) --

ANIM = {} 

----------------------------------------------------------|
----------------------------------------------------------|
-- SIMPLE FUNCTIONS -----------------------|
----------------------------------------------------------|
----------------------------------------------------------|


-- LOAD ANIMATION --

function ANIM.new(header, extension, frames, where)

where = where or "./"

frames = frames
header = header
extension = extension

local load

local c = setmetatable(
	{
		interval = 0,
		currentFrame = 1,
		maxFrame = frames,
		looped = 0, -- Looping or not --
		loops = 1, -- How many loops have occured --
		frame = {},
		timer = Timer.new(),
	},
    	{
     		__index = ANIM
    	}
)

for load = 1, frames do
	c.frame[load] = Image.load(where..header..load.."."..extension) 
end

return c

end



-- BLIT ANIMATION --

function ANIM:blit(x, y, delay, numLoops)

numLoops = numLoops or 0

if numLoops == 0 then
	self.looped = 0
	self.loops = 0
else
	self.looped = 1
	if self.loops == 0 then -- Just in case the animation reverts back to looped --
		self.loops = 1
	end
end

self.interval = delay
self.timer:start()

	if self.loops <= numLoops then

		if self.timer:time() >= self.interval then
			self.currentFrame = self.currentFrame + 1
			self.timer:reset()
		end	

		if self.currentFrame > self.maxFrame then
			if self.looped == 1 then
				self.loops = self.loops + 1
			end
			self.currentFrame = 1
		end 

		Image.blit(x, y, self.frame[self.currentFrame])

	end
end


-- PAUSE ANIMATION --

function ANIM:pause()
	self.timer:stop()
end

-- RESUME ANIMATION --

function ANIM:resume()
	self.timer:start()
end

-- RESET ANIMATION --

function ANIM:reset(num)
	num = num or 1
	self.currentFrame = num
end

-- FREE ANIMATION FROM RAM --

function ANIM:free()
	local f
	
	for f = 1, self.maxFrame do
		self.frame[f] = nil
	end
	
	f = nil
	
	collectgarbage()
end

----------------------------------------------------------|
----------------------------------------------------------|
-- ADVANCED FUNCTIONS -----------------|
----------------------------------------------------------|
----------------------------------------------------------|

-- RESTORE LOOP NUMBER --

function ANIM:resetLoop()
	self.loops = 1
end

-- RETURN THE CURRENT TIMER TIME --

function ANIM:getTime()
	return self.timer:time()
end

-- RETURN THE CURRENT FRAME --

function ANIM:getFrame()
	return self.currentFrame
end

-- RETURN THE CURRENT NUMBER OF LOOPS MADE --

function ANIM:getLoops()
	return self.loops
end



----------------------------------------------------------|
----------------------------------------------------------|
-- SPRITESHEET FUNCTIONS -----------------|
----------------------------------------------------------|
----------------------------------------------------------|


SS = {} 


-- LOAD SPRITESHEET --

function SS.new(header, extension, nWidth, nHeight, where)

where = where or "./"

header = header
extension = extension
nRows = nRows
nColumns = nColumns
nWidth = nWidth
nHeight = nHeight


local c = setmetatable(
	{
		interval = 0,
		width = nWidth,
		height = nHeight,
		ppR = 0,	-- Pics Per Row --	
		ppC = 0,	-- Pics Per Column --
		
		cRow = 0,
		cColumn = 0,

		looped = 0, -- Looping or not --
		loops = 1, -- How many loops have occured --
		pic = nil,
		timer = Timer.new(),
	},
    	{
     		__index = SS
    	}
)

-- Load Image --

c.pic = Image.load(where..header.."."..extension) 

-- Set Sizes --

c.ppR = (c.pic:width() / c.width) - 1
c.ppC = (c.pic:height() / c.height) - 1

return c

end


-- BLIT SS --

function SS:blit(x, y, delay, numLoops)

numLoops = numLoops or 0

if numLoops == 0 then
	self.looped = 0
	self.loops = 0
else
	self.looped = 1
	if self.loops == 0 then -- Just in case the animation reverts back to looped --
		self.loops = 1
	end
end

self.interval = delay
self.timer:start()

	if self.loops <= numLoops then

		-- Loop --
	
		if self.timer:time() >= self.interval then
			self.cColumn = self.cColumn + 1
			self.timer:reset()
		end

		-- Limits --

		if self.cColumn > self.ppR then
			self.cRow = self.cRow + 1
			self.cColumn = 0
		end

		if self.cRow > self.ppC then
			if self.looped == 1 then
				self.loops = self.loops + 1
			end
			self.cRow = 0
		end
	

		Image.blit(x, y, self.pic, self.cColumn * self.width, self.cRow * self.height, self.width, self.height) 
	
	end
end

----------------------------------------------------------|
----------------------------------------------------------|
-- ADVANCED FUNCTIONS -----------------|
----------------------------------------------------------|
----------------------------------------------------------|

-- PAUSE ANIMATION --

function SS:pause()
	self.timer:stop()
end

-- RESUME ANIMATION --

function SS:resume()
	self.timer:start()
end

-- RESET ANIMATION --

function SS:reset()
	self.cRow = 0
	self.cColumn = 0
end

-- FREE ANIMATION FROM RAM --

function SS:free()
	self.pic = nil
	collectgarbage()
end


-- RESTORE LOOP NUMBER --

function SS:resetLoop()
	self.loops = 1
end

-- RETURN THE CURRENT TIMER TIME --

function SS:getTime()
	return self.timer:time()
end

-- RETURN THE CURRENT Row --

function SS:getRow()
	return self.cRow
end

-- RETURN THE CURRENT Column --

function SS:getColumn()
	return self.cColumn
end

-- RETURN THE CURRENT NUMBER OF LOOPS MADE --

function SS:getLoops()
	return self.loops
end