--Variables de Colores
yellow = Color.new(255,255,0,255)
green = Color.new(0, 255, 0,255)
red = Color.new(255,0,0,255)
white = Color.new(255,255,255,255)
black = Color.new(0,0,0,255)
blue = Color.new(0,0,255,255)

--Variables de Sonidos
boink = Sound.load("sonidos/boink.wav")
loka = Sound.load("sonidos/loka.wav")
other = Sound.load("sonidos/other.wav")
cloak = Sound.load("sonidos/cloak.wav")
stflash = Sound.load("sonidos/stflash.wav")
click = Sound.load("sonidos/click.wav")
beep = Sound.load("sonidos/beep.wav")
pik = Sound.load("sonidos/pik.wav")

PSPCLibLoad()

--Refrescar Memoria
PSPCleanMemoryRam()

--Variables Sistema/Homebrew
engine = 0
change = 0
speed = 3
flashing = 0
cursor = 0
varx = 4
vary = 4
alto = 0
cpuspeed = System.getCpuSpeed()
mol = 0 
savepsp = 0
alarmon = 0
molestar = 0


--Variables Hora
reloj = {}
reloj.x = 10
reloj.y = 10
reloj.current = blue
reloj.hora = 2
reloj.minuto = 20
reloj.meridiano= "pm"
reloj.selector = 1
reloj.custom1 = red
reloj.custom2 = yellow
reloj.custom3 = yellow
reloj.custom4 = yellow
reloj.final = 0

--Variables Cursores
fixer = {}
fixer.x = 10
fixer.y = 10
fixer.current = blue

fixer2 = {}
fixer2.x = 140
fixer2.y = 40
fixer2.current = fixer.current

fixer3 = {}
fixer3.x = 340
fixer3.y = 40
fixer3.current = fixer.current

fixer4 = {}
fixer4.x = 340
fixer4.y = 240
fixer4.current = fixer.current

scol = {}
scol.x = 0
scol.y = 0
scol.current = black



--Funcion de cambio de color
function color()
engine = engine+1
if engine>14 or engine<0 then
engine=1 
end
if engine==1 and scol.current ~= yellow then
fixer.current = yellow
end
if engine==4 and scol.current ~= green then
fixer.current = green
end
if engine==6 and scol.current ~= red then
fixer.current = red
end
if engine==8 and scol.current ~= white then
fixer.current = white
end
if engine==10 and scol.current ~= black then
fixer.current = black
end
if engine==12 and scol.current ~= blue then
fixer.current = blue
end
end



--Funcion de cambio de color 2da
function bakolor()
if change>6 or change<0 then
change=1 
end
if change==1 and fixer.current ~= yellow then
scol.current = yellow
end
if change==2 and fixer.current ~= green then
scol.current = green
end
if change==3 and fixer.current ~= red then
scol.current = red
end
if change==4 and fixer.current ~= white then
scol.current = white
end
if change==5 and fixer.current ~= black then
scol.current = black
end
if change==6 and fixer.current ~= blue then
scol.current = blue
end
end



--Funcion para Suspension
function alarmengine()
if alarmon == 0 then
System.message("Te gustaria que al terminar se suspenda tu PSP?",1)
if System.buttonPressed() ==1 then 

alarmon =1
savepsp = 1
end
if System.buttonPressed() ==2 then 
alarmon = 3
end
if System.buttonPressed() ==3 then 
alarmon = 3
end
end
end

oldpad = Controls.read()

--Regresar al System.message
while true do
if alarmon == 0 then
alarmengine()
end
--Empezar motor de impresion
screen.startDraw()
screen.clear(0)
--Declarar imagen vacia
fixerscreen=Image.createEmpty(varx,vary)
fixerscreen:clear(fixer.current)

bakolor()
--Variables de tiempo 2das
time = os.time()
min =  System.getTime(2)
hour = System.getTime(1)
statap =  System.getTime(5)


if varx >= 20 then
varx = 4
end

if vary >= 20 then
vary = 4
end

if cursor >= 4 then
cursor = 0
end

if flashing == 1 then
color()
end

if speed >= 6 then
speed = 2
end

if flashing >= 2 then
flashing = 0
end

--Leer/Activar Controles
pad = Controls.read()



--Acciones principales
if pad:triangle() and oldpad:triangle() ~= pad:triangle() then
beep:play()
PSPCDofileExtras2()

end

if pad:select() and oldpad:select() ~= pad:select() and savepsp ~= 1 then
cursor = cursor + 1
other:play()
end

if pad:r() and oldpad:r() ~= pad:r() and savepsp ~= 1 then
change = change + 1
cloak:play()
end

if pad:square() and oldpad:square() ~= pad:square() and savepsp ~= 1 then
flashing = flashing + 1
stflash:play()
end

if pad:circle() and oldpad:circle() ~= pad:circle() and savepsp ~= 1 then
varx = varx + 4
vary = vary + 4
boink:play()
end


--Poner PSP en Cpu Frecuencia Baja
if System.powerIsLowBattery() == true and cpuspeed =="111" then
PSPCStandby()
end


if pad:cross() and oldpad:cross() ~= pad:cross() and savepsp ~= 1 then
speed = speed + 1
click:play()
end

--cursor #1
if pad:up() and fixer.y >= -1 and cursor == 0 and savepsp ~= 1 then
fixer.y = fixer.y - speed
end

if pad:down() and fixer.y + vary <= 271 and cursor == 0 and savepsp ~= 1  then
fixer.y = fixer.y + speed
end

if pad:right() and fixer.x + varx <= 481 and cursor == 0 and savepsp ~= 1 then
fixer.x = fixer.x + speed
end

if pad:left() and fixer.x >= -1 and cursor ==0 and savepsp ~= 1 then
fixer.x = fixer.x - speed
end

--cursor #2
if pad:up() and fixer2.y >= -1 and cursor == 1 and savepsp ~= 1 then
fixer2.y = fixer2.y - speed
end

if pad:down() and fixer2.y + vary <= 271 and cursor == 1 and savepsp ~= 1 then
fixer2.y = fixer2.y + speed
end

if pad:right() and fixer2.x + varx <= 481 and cursor == 1 and savepsp ~= 1 then
fixer2.x = fixer2.x + speed
end

if pad:left() and fixer2.x >= -1 and cursor ==1 and savepsp ~= 1 then
fixer2.x = fixer2.x - speed
end

--cursor #3
if pad:up() and fixer3.y >= -1 and cursor == 2 and savepsp ~= 1 then
fixer3.y = fixer3.y - speed
end

if pad:down() and fixer3.y + vary <= 271 and cursor == 2 and savepsp ~= 1 then
fixer3.y = fixer3.y + speed
end

if pad:right() and fixer3.x + varx <= 481 and cursor == 2 and savepsp ~= 1 then
fixer3.x = fixer3.x + speed
end

if pad:left() and fixer3.x >= -1 and cursor ==2 and savepsp ~= 1 then
fixer3.x = fixer3.x - speed
end

--cursor #4
if pad:up() and fixer4.y >= -1 and cursor == 3 and savepsp ~= 1 then
fixer4.y = fixer4.y - speed
end

if pad:down() and fixer4.y + vary <= 271 and cursor == 3 and savepsp ~= 1 then
fixer4.y = fixer4.y + speed
end

if pad:right() and fixer4.x + varx <= 481 and cursor == 3 and savepsp ~= 1 then
fixer4.x = fixer4.x + speed
end

if pad:left() and fixer4.x >= -1 and cursor ==3 and savepsp ~= 1 then
fixer4.x = fixer4.x - speed
end



--Impresion de correctores de pixel
Image.fillRect(scol.x,scol.y,480,280,scol.current)
Image.blit(fixer.x,fixer.y,fixerscreen)
Image.blit(fixer2.x,fixer2.y,fixerscreen)
Image.blit(fixer3.x,fixer3.y,fixerscreen)
Image.blit(fixer4.x,fixer4.y,fixerscreen)

--Tiempo para Suspender
if savepsp == 1 then
screen.clear(0)

sec = System.getTime(3)
	min =  System.getTime(2)
	hour = System.getTime(1)
	statap =  System.getTime(5)
if hour < 10 then
hour = "0" .. hour
end
if min < 10 then
min = "0" .. min
end

	globaldate = hour..":"..min..":"..sec.." "..statap
	
	if reloj.selector <= 1 then
	reloj.selector =1
	end
	if reloj.selector >= 4 then
	reloj.selector =4
	end
	if pad:right()and oldpad:right() ~= pad:right() then
reloj.selector = reloj.selector + 1
pik:play()
end

	if pad:left()and oldpad:left() ~= pad:left() then
reloj.selector = reloj.selector - 1
pik:play()
end

if reloj.selector == 3 then
reloj.selector = 3
reloj.custom3 = red
reloj.custom2 = yellow
reloj.custom1 = yellow
reloj.custom4 = yellow
if pad:up()and oldpad:up() ~= pad:up() and reloj.meridiano == "am" then
reloj.meridiano = "pm"
boink:play()
end
if pad:down()and oldpad:down() ~= pad:down() and reloj.meridiano == "pm" then
reloj.meridiano = "am"
boink:play()
end
end


if reloj.selector >= 4 then
reloj.selector = 4
reloj.custom4 = red
reloj.custom2 = yellow
reloj.custom1 = yellow
reloj.custom3 = yellow
if pad:square()and oldpad:square() ~= pad:square() then
savepsp = 3
end
end



if reloj.selector == 2 then
reloj.selector = 2
reloj.custom2 = red
reloj.custom3 = yellow
reloj.custom1 = yellow
reloj.custom4 = yellow
if pad:up()and oldpad:up() ~= pad:up() and reloj.minuto < 59 then
reloj.minuto = reloj.minuto + 1
boink:play()
end
if pad:down()and oldpad:down() ~= pad:down() and reloj.minuto > 0 then
reloj.minuto = reloj.minuto - 1
boink:play()
end
end


if reloj.selector <= 1 then
reloj.selector = 1
reloj.custom3 = yellow
reloj.custom2 = yellow
reloj.custom1 = red
reloj.custom4 = yellow
if pad:up()and oldpad:up() ~= pad:up() and reloj.hora < 12 then
reloj.hora = reloj.hora + 1
boink:play()
end
if pad:down()and oldpad:down() ~= pad:down() and reloj.hora > 1 then
reloj.hora = reloj.hora - 1
boink:play()
end
end

--Impresiones para la alarma
screen.print(20,40,"Would you like that in the end, your PSP..",1,red,40)
screen.print(100,90,reloj.hora .." :",1,reloj.custom1,80)
screen.print(160,90,reloj.minuto,1,reloj.custom2,80)
screen.print(220,90,reloj.meridiano,1,reloj.custom3,80)
screen.print(280,90,"|Activate|",1,reloj.custom4,80)
screen.print(100,180,"Current time: " ..globaldate,1,blue,80)
end
----------------------------------------------------------------------------------------

--Motor de arranque de la alarma/ Alarm starting engine
if savepsp == 3 and reloj.hora == hour and reloj.minuto -1 == min and reloj.meridiano == statap and molestar == 0 then
System.setVolume(30)
loka:play()
molestar = 1
end

if savepsp == 3 and reloj.hora == hour and reloj.minuto == min and reloj.meridiano == statap  then
cloak:play()
System.suspend()
savepsp = 4
end

PSPCleanMemoryRam()
screen.endDraw()
screen.flipscreen()
screen.waitVblankStart()
oldpad = pad
end